/* Copyright (C) 'H' model transistor B.S.J.W. Stephenson 19/2/2008 & 20/3/2008 & 4/4/08 & 3/6/08 & 11/6/08*/
/* A.K.A the Black Box Model Transistor ,Bibliographic ref. Mullard,Dio-tech etal '54->? */
/*
/*  This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

# include <stdio.h>
# include <limits.h> 
# include <stdarg.h>
# include <float.h>
# include <math.h>
# include <string.h>
# include "./BBBMTdefs6.h"

newtran print_H_functions( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{
printf("\n\n Print output for verification final");
printf("\n\n PowerDissipation=%G %s",tran1->PowerDissipation," for Generate_H_functions ");
printf("\n Junction_temperature =%G %G%s",tran1->Junction_temperature ," for Generate_H_functions ");
printf("\n sink_temperature=%G%s" ,tran1->sink_temperature," for Generate_H_functions" ) ;

printf("\n\n Noise_on =%d " , tran1->noise_on ) ;
printf("\n Configuration =%d " ,tran1->configuration ) ;
printf("\n Compound_thermal_baseimp_on =%d " ,tran1->Compound_thermal_baseimp_on ) ;
printf("\n Compound_thermal_beta_on =%d " ,tran1->Compound_thermal_beta_on ) ;

printf("\n\n rload_absolute  =%G" , tran1->rload_absolute ) ;
printf("\n rload =%G " , tran1->rload ) ;
printf("\n rload_theta =%G " , tran1->rload_theta ) ;
printf("\n rload_mag =%G " , tran1->rload_mag ) ;

printf("\n\n Ione[pre_n2] =%G" , tran1->Ione[pre_n2] ) ;
printf("\n Ione_total=%G" , tran1->Ione_total ) ;
printf("\n Ione_total_mag=%G" , tran1->Ione_total_mag ) ;
printf("\n Ione_total_theta=%G" , tran1->Ione_total_theta ) ;

printf("\n\n Itwo[n]=%G%s" , tran1->Itwo[n]," for Generate_H_functions " ) ;
printf("\n (emitter out) Itwo_total=%G" , tran1->Itwo_total ) ;
printf("\n Itwo_total_mag=%G" , tran1->Itwo_total_mag ) ;
printf("\n Itwo_total_theta=%G" , tran1->Itwo_total_theta ) ;
printf("\n Itwo_collector=%G" , tran1->Itwo_collector) ;
printf("\n Itwo_collector_mag=%G" , tran1->Itwo_collector_mag ) ;
printf("\n Itwo_collector_theta=%G" , tran1->Itwo_collector_theta ) ;

printf("\n\n current model") ;
printf("\n Uoneout_mag =%G %s" , tran1->Uoneout_mag," Generate_H_functions" ) ;
printf("\n Uoneout_theta =%G %s" , tran1->Uoneout_theta," Generate_H_functions" ) ;
printf("\n Uoneout_absolute =%G %s" , tran1->Uoneout_absolute," Generate_H_functions" ) ;
printf("\n push_pull_Uone=%G %s" ,tran1->push_pull_Uone,"  " ) ;
printf("\n Uoneout =%G %s" , tran1->Uoneout," Generate_H_functions" ) ;
printf("\n IUone_out=%G" , tran1->IUone_out ) ;
printf("\n IUone_out_theta=%G" , tran1->IUone_out_theta ) ;

printf("\n\n current model") ;
printf("\n Utwoout_mag =%G" , tran1->Utwoout_mag ) ;
printf("\n Utwoout_theta =%G" , tran1->Utwoout_theta ) ;
printf("\n Utwoout_absolute =%G" , tran1->Utwoout_absolute ) ;
printf("\n push_pull_Utwo=%G %s" ,tran1->push_pull_Utwo,"  " ) ;
printf("\n Utwoout =%G" , tran1->Utwoout ) ;

printf("\n\n h11_absolute =%G" , tran1->h11_absolute ) ;
printf("\n h11 =%G" , tran1->h11 ) ;
printf("\n h11_theta =%G" , tran1->h11_theta ) ;
printf("\n h11_mag =%G" , tran1->h11_mag ) ;

printf("\n\n h12_mag =%G" , tran1->h12_mag ) ;
printf("\n h12 =%G" , tran1->h12 ) ;
printf("\n h12_theta =%G" , tran1->h12_theta ) ;
printf("\n h12_absolute =%G" , tran1->h12_absolute ) ;

printf("\n\n h21_mag =%G" , tran1->h21_mag ) ;
printf("\n h21_theta =%G" , tran1->h21_theta ) ;
printf("\n h21_absolute =%G" , tran1->h21_absolute ) ;
printf("\n beta[n]=%G %s" , tran1->beta[n] ,"") ;

printf("\n\n h22_mag =%G" , tran1->h22_mag ) ;
printf("\n h22_theta =%G" , tran1->h22_theta ) ;
printf("\n h22_absolute =%G" , tran1->h22 ) ;


printf("\n\n voltage_acrossC12_absolute=%G" ,tran1->voltage_acrossC12_absolute ) ;
printf("\n Zc12=%G" , tran1->Zc12[pre_n3] ) ;
printf("\n C12=%G" ,tran1->C12 ) ;
printf("\n Ic12[pre_n3]= %G" , tran1->Ic12[pre_n3] ) ;
printf("\n I_leakage_Cap_1_2=%G %s" ,tran1->I_leakage_Cap_1_2," " ) ;
printf("\n Ic12_theta[pre_n3]= %G" , tran1->Ic12_theta[pre_n3] ) ;
printf("\n R_leakage_Cap_1_2=%G %s" ,tran1->R_leakage_Cap_1_2," " ) ;

printf("\n\n frequency_Uone=%G%s" ,tran1->frequency_Uone,"" ) ;
printf("\n frequency_Utwo=%G%s" ,tran1->frequency_Utwo,"" ) ;
printf("\n frequency_Uzero=%G%s" ,tran1->frequency_Uzero,"" ) ;

printf("\n\n voltage_acrossC10_absolute= %G" ,tran1->voltage_acrossC10_absolute ) ;
printf("\n Zc10= %G" , tran1->Zc10[pre_n3] ) ;
printf("\n C10= %G" ,tran1->C10 ) ;
printf("\n Ic10[pre_n3]= %G" ,tran1->Ic10[pre_n3] ) ;
printf("\n Ic10_theta[pre_n3]= %G%s" ,tran1->Ic10_theta[pre_n3] ) ;

/*
printf("\n\n  n =%d %d%s" , tran1->n,n,"  n for Generate_H_functions " ) ;
printf("\n  pre_n1 =%d%s" ,pre_n1,"  pre_n1 for Generate_H_functions " ) ;
printf("\n  pre_n2 =%d%s" ,pre_n2,"  pre_n2 for Generate_H_functions " ) ;
printf("\n  pre_n3 =%d%s" ,pre_n3,"  pre_n3 for Generate_H_functions " ) ;
*/
	return *tran1  ;

}/* end print_H_function function */

newtran Generate_I_1_total_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{

double Ione[10],Ione_mag,Ione_theta,Ic10,Ic10_theta,Ic12,Ic12_theta,Ione_total,Ione_total_mag,Ione_total_theta ;
double Ione_total_real,Ione_total_imaginary,Ione_total_square,IUone_out,IUone_out_theta ;

Ic10 = tran1->Ic10[pre_n3] ;
Ic10_theta = tran1->Ic10_theta[pre_n3] ;
Ic12 = tran1->Ic12[pre_n3] ;
Ic12_theta = tran1->Ic12_theta[pre_n3] ;
Ione[pre_n2] = tran1->Ione[pre_n2] ;
Ione_theta = tran1->Ione_theta[pre_n2] ;

Ione_mag = Ione[pre_n2] / sin(Ione_theta) ;
tran1->Ione_mag = Ione_mag ;

/* this may be inefficient , but I think it is self explanatory */
IUone_out = tran1->Ic12[pre_n3] ;
IUone_out_theta = tran1->Ic12_theta[pre_n3] ;

Ione_total_real = ( Ione_mag * cos(Ione_theta)) + ( Ic10 * cos(Ic10_theta)) + (Ic12 * cos(Ic12_theta)) + (IUone_out * cos(IUone_out_theta)) ;
Ione_total_imaginary = ( Ione_mag * sin(Ione_theta)) + ( Ic10 * sin(Ic10_theta)) + (Ic12 * sin(Ic12_theta)) + (IUone_out * sin(IUone_out_theta)) ;

Ione_total_theta = atan(Ione_total_imaginary / Ione_total_real) ;

Ione_total_square = pow(Ione_total_real,2) + pow(Ione_total_imaginary,2) ;

Ione_total_mag = sqrt(Ione_total_square) ;

Ione_total = Ione_total_mag * sin(Ione_total_theta) ;

tran1->Ione_total = Ione_total ;
tran1->Ione_total_mag = Ione_total_mag ;
tran1->Ione_total_theta = Ione_total_theta ;
tran1->IUone_out = IUone_out ; 
tran1->IUone_out_theta = IUone_out_theta ;
tran1->Ione_mag = Ione_mag ;

	return *tran1  ;

}/* END generate I_1_total_function */

newtran Generate_I_2_total_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{

double Itwo[12],Itwo_mag,Itwo_theta,Ic10,Ic10_theta,Ic12,Ic12_theta,Itwo_total,Itwo_total_mag,Itwo_total_theta ;
double Itwo_total_real,Itwo_total_imaginary,Itwo_total_square,IUone_out,IUone_out_theta ;
double Itwo_collector_real,Itwo_collector_imaginary,Itwo_collector_theta,Itwo_collector_square,Itwo_collector_mag ;
double Itwo_collector ;

Ic10 = tran1->Ic10[pre_n3] ;
Ic10_theta = tran1->Ic10_theta[pre_n3] ;
Ic12 = tran1->Ic12[pre_n3] ;
Ic12_theta = tran1->Ic12_theta[pre_n3] ;
Itwo[n] = tran1->Itwo[n] ;
Itwo_theta = tran1->Utwoinittheta ; 

Itwo_mag = Itwo[n] / sin(Itwo_theta) ;
tran1->Itwo_mag = Itwo_mag ;

/* this may be inefficient , but I think it is self explanatory */
IUone_out = tran1->Ic12[pre_n3] ;
IUone_out_theta = tran1->Ic12_theta[pre_n3] ;

Itwo_collector_real = ( Itwo_mag * cos(Itwo_theta)) + (IUone_out * cos(IUone_out_theta)) ;

Itwo_total_real = Itwo_collector_real + ( Ic10 * cos(Ic10_theta))  ;

Itwo_collector_imaginary = ( Itwo_mag * sin(Itwo_theta)) + (IUone_out * sin(IUone_out_theta)) ;

Itwo_total_imaginary = Itwo_collector_imaginary + ( Ic10 * sin(Ic10_theta)) ;

Itwo_collector_theta = atan(Itwo_collector_imaginary / Itwo_collector_real) ;

tran1->Itwo_collector_theta = Itwo_collector_theta ;

Itwo_collector_square = pow(Itwo_collector_real,2) + pow(Itwo_collector_imaginary,2) ;

Itwo_collector_mag = sqrt(Itwo_collector_square) ;

tran1->Itwo_collector_mag = Itwo_collector_mag ;

Itwo_total_theta = atan(Itwo_total_imaginary / Itwo_total_real) ;

tran1->Itwo_total_theta = Itwo_total_theta ;

Itwo_total_square = pow(Itwo_total_real,2) + pow(Itwo_total_imaginary,2) ;

Itwo_total_mag = sqrt(Itwo_total_square) ;

tran1->Itwo_total_mag = Itwo_total_mag ;

Itwo_collector = Itwo_collector_mag * sin(Itwo_collector_theta) ;

tran1->Itwo_collector = Itwo_collector ;

Itwo_total = Itwo_total_mag * sin(Itwo_total_theta) ;

tran1->Itwo_total = Itwo_total ;


tran1->IUone_out = IUone_out ; 
tran1->IUone_out_theta = IUone_out_theta ;
tran1->Itwo_mag = Itwo_mag ;

	return *tran1  ;

}/* END generate I_2_total_function */

 newtran Generate_self_induced_load_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{

double Ione[10],Itwo[12],Itwo_mag,Itwo_theta,beta[12],Uone_theta,Ione_mag,Ione_theta,Uone_mag ;
double Utwoinit,emitterin,emitterout,Uone,Uoneout,deltah,h12,rgopt,rlopt ;
double pin_resistance,PowerDissipation,Junction_temperature,Utwo_absolute,Utwo_mag,Utwo_theta,Ic12,Ic12_theta,Ic10,Ic10_theta ;
double h12_a,h12_mag,h12_theta,h12_absolute ;
double rload,rload_mag,rload_theta,rload_theta_part_2,rloada,rload_absolute,rload_real_part_1,rload_real_part_2,rload_imaginary_part_1 ;
double rload_imaginary_part_2,rload_square_part_1,rload_square_part_2,rload_mag_part_1,rload_mag_part_2 ;
double Itwo_total,Itwo_total_mag,Itwo_total_theta ;

/* now generate the self induced load */

tran1->n = n ;
Utwo_absolute = tran1->Utwo_absolute ;
Itwo[n] = tran1->Itwo[n] ;
Ic10 = tran1->Ic10[pre_n3] ;
Ic10_theta = tran1->Ic10_theta[pre_n3] ;
Utwo_theta = tran1->Utwo_theta ;
Utwo_mag = tran1->Utwo_mag ;

Itwo_total = tran1->Itwo_total ;
Itwo_total_mag = tran1->Itwo_total_mag ;
Itwo_total_theta = tran1->Itwo_total_theta ;
Itwo_mag = tran1->Itwo_mag ;
Itwo_theta = tran1->Itwo_total_theta ;


	rload = Utwo_absolute /  Itwo_total ;

	rload_real_part_1 = Utwo_mag * cos(Utwo_theta) ;

	rload_real_part_2 = ( Itwo_total_mag * cos(Itwo_theta)) ; 
 
	rload_imaginary_part_1 = Utwo_mag * sin(Utwo_theta) ;

	rload_imaginary_part_2 = ( Itwo_total_mag * sin(Itwo_theta)) ; 

	rload_square_part_1 = pow(rload_real_part_1,2) + pow(rload_imaginary_part_1,2) ;

	rload_square_part_2 = pow(rload_imaginary_part_2,2) + pow(rload_real_part_2,2) ;

	rload_mag_part_1 = sqrt(rload_square_part_1) ;

	rload_mag_part_2 = sqrt(rload_square_part_2) ;

	rload_theta_part_2 = atan(rload_imaginary_part_2 / rload_real_part_2) ;

	rload_absolute = (rload_mag_part_1 * sin(Utwo_theta)) / (rload_mag_part_2 * sin(rload_theta_part_2)) ;

	rload_theta = Utwo_theta - rload_theta_part_2  ;

	rload_mag = rload_mag_part_1 / rload_mag_part_2  ;

tran1->rload = rload ;
tran1->rload_theta  = rload_theta ;
tran1->rload_mag = rload_mag ;
tran1->rload_absolute = rload_absolute ;

	return *tran1  ;

}/* END generate the self induced load */

 newtran Generate_h11_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{

double h11,h11a,h11_mag,h11_theta,h11_absolute_part_1,h11_real_part_2,h11_imaginary_part_2,h11_theta_part_2,h11_square_part_2,h11_root_part_2 ;
double h11_absolute,h11_absolute_part_2,Ic10,Ic10_theta,h11a_absolute ;
double Uone,Uone_mag,Uone_theta,Ione[10],Ione_theta,Ione_mag,Ic12,Ic12_theta ;
double Ione_total,Ione_total_mag,Ione_total_theta,h11a_theta,h11a_mag ;

Uone = tran1->Uone ;
Ione[pre_n2] = tran1->Ione[pre_n2] ;
Ic12 = tran1->Ic12[pre_n3] ;
Ic12_theta = tran1->Ic12_theta[pre_n3] ;
Ic10 = tran1->Ic10[pre_n3] ;
Ic10_theta = tran1->Ic10_theta[pre_n3] ;
Uone_theta = tran1->Uone_theta ;
Uone_mag = tran1->Uone_mag ;

Ione_total = tran1->Ione_total ;
Ione_total_mag = tran1->Ione_total_mag ;
Ione_total_theta = tran1->Ione_total_theta ;
Ione_mag = tran1->Ione_mag ;
Ione_theta = tran1->Ione_total_theta ;

	h11 = Uone / ( Ione[pre_n2] + (Ic12 * sin(Ic12_theta)) + (Ic10 * sin(Ic10_theta))) ;
	

	h11_real_part_2 = ( Ione_mag * cos(Ione_theta)) + ( Ic12 * cos(Ic12_theta)) + (Ic10 * cos(Ic10_theta)) ;

	h11_imaginary_part_2 = ( Ione_mag * sin(Ione_theta)) + ( Ic12 * sin(Ic12_theta)) + (Ic10 * sin(Ic10_theta)) ;
 
	h11_theta_part_2 = atan(h11_imaginary_part_2 / h11_real_part_2) ;

	h11_square_part_2 = pow(h11_real_part_2,2) + pow(h11_imaginary_part_2,2) ;

	h11_absolute_part_2 = sqrt(h11_square_part_2) ;

	h11_theta = Uone_theta - h11_theta_part_2 ;

	h11_absolute = Uone / (h11_absolute_part_2 * sin(h11_theta_part_2)) ;

tran1->h11 = h11 ;
tran1->h11_theta = h11_theta ;
tran1->h11_mag = h11_absolute_part_2 ;
tran1->h11_absolute = h11_absolute ;

	return *tran1  ;

}/* END generate H11 */

 newtran Generate_h21_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{

double h21,h21a,h21_mag,h21_theta,h21_absolute,h21_real_part_1,h21_imaginary_part_1,h21_theta_part_1,h21_square_part_1,h21_mag_part_1 ;
double h21_real_part_2,h21_imaginary_part_2,h21_theta_part_2,h21_square_part_2,h21_mag_part_2 ;
double Itwo[12],Itwo_mag,Itwo_theta,Ione[10],Ione_mag,Ione_theta,Ic10,Ic10_theta,Ic12,Ic12_theta ;
double Ione_total,Ione_total_mag,Ione_total_theta ;
double Itwo_total,Itwo_total_mag,Itwo_total_theta ;

Itwo[n]= tran1->Itwo[n] ;
Ione[pre_n2] = tran1->Ione[pre_n2] ;
Ic10 = tran1->Ic10[pre_n3] ;
Ic10_theta = tran1->Ic10_theta[pre_n3] ;
Ic12 = tran1->Ic12[pre_n3] ;
Ic12_theta = tran1->Ic12_theta[pre_n3] ;

Itwo_total = tran1->Itwo_total ;
Itwo_total_mag = tran1->Itwo_total_mag ;
Itwo_total_theta = tran1->Itwo_total_theta ;
Itwo_mag = tran1->Itwo_mag ;
Itwo_theta = tran1->Itwo_total_theta ;

Ione_total = tran1->Ione_total ;
Ione_total_mag = tran1->Ione_total_mag ;
Ione_total_theta = tran1->Ione_total_theta ;
Ione_mag = tran1->Ione_mag ;
Ione_theta = tran1->Ione_total_theta ;
/* sorry to have transposed mag and absolute in this one */
	h21 =  Itwo_total / Ione_total  ;

	h21_real_part_1 = ( Itwo_mag * cos(Itwo_theta)) + ( Ic12 * cos(Ic12_theta)) ;
	h21_imaginary_part_1 = ( Itwo_mag * sin(Itwo_theta)) + ( Ic12 * sin(Ic12_theta)) ;
	h21_theta_part_1 = atan(h21_imaginary_part_1 / h21_real_part_1) ;
	h21_square_part_1 = pow(h21_real_part_1,2) + pow(h21_imaginary_part_1,2) ;
	h21_mag_part_1 = sqrt(h21_square_part_1) ;

	h21_real_part_2 = ( Ione_mag * cos(Ione_theta)) + (Ic12 * cos(Ic12_theta)) + (Ic10 * cos(Ic10_theta)) ;
	h21_imaginary_part_2 = ( Ione_mag * sin(Ione_theta)) + (Ic12 * sin(Ic12_theta)) + (Ic10 * sin(Ic10_theta)) ;
	h21_theta_part_2 = atan(h21_imaginary_part_2 / h21_real_part_2) ;
	h21_square_part_2 = pow(h21_real_part_2,2) + pow(h21_imaginary_part_2,2) ;
	h21_mag_part_2 = sqrt(h21_square_part_2) ;

	h21_mag = h21_mag_part_1 / h21_mag_part_2 ;
	h21_theta = h21_theta_part_1 - h21_theta_part_2 ;
 	h21_absolute = (h21_mag_part_1 *  sin(h21_theta_part_1)) / (h21_mag_part_2 * sin(h21_theta_part_2)) ;

tran1->h21_absolute = h21_absolute ;
tran1->h21_theta = h21_theta ;
tran1->h21_mag = h21_mag ;
tran1->h21 = h21 ;

	return *tran1  ;

}/* END generate H21 */

 newtran Generate_h22_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{
/*			p1	     r1		p2	r2				*/
double h22A,h22M,h22_mag_part_1a,h22_mag_part_1b,h22_mag_part_2a,h22_mag_part_2b,h22_mag,h22_theta,h22_absolute ;
double h22_real_part_1,h22_imaginary_part_1,h22_theta_part_1,h22_square_part_1,h22_mag_part_1 ;
double h22_real_part_2,h22_imaginary_part_2,h22_theta_part_2,h22_square_part_2,h22_mag_part_2 ;
double h21,h21_absolute,h21_mag,h21_theta,beta[12],rload,rload_absolute,rload_mag,rload_theta,pin_resistance ;
double Itwo[12],Itwo_mag,Itwo_theta,Ione[10],Ione_mag,Ione_theta,Utwo_absolute,Utwo_mag,Utwo_theta ;
double h22M_real_part_1,h22M_imaginary_part_1,h22M_theta_part_1,h22M_square_part_1,h22M_mag_part_1 ;
double h22M_mag,h22M_theta,h22M_absolute,h22M_mag_part_1a,h22M_theta_part_1a ;
double Ione_total,Ione_total_mag,Ione_total_theta ;
double Itwo_total,Itwo_total_mag,Itwo_total_theta ;
double h22M1_theta,h22M1,h22M1_mag ;

h21 = tran1->h21 ;
h21_mag = tran1->h21_mag ;
h21_absolute = tran1->h21_absolute ;
h21_theta = tran1->h21_theta ;
beta[pre_n1] = tran1->beta[pre_n1] ; 
rload = tran1->rload ;
rload_mag = tran1->rload_mag ;
rload_theta = tran1->rload_theta ;
pin_resistance = tran1->pin_resistance_two ;

Itwo[n]= tran1->Itwo[n] ;
Itwo_theta = tran1->Uone_theta ;
Itwo_mag = tran1->Itwo_mag ;
Ione[pre_n2] = tran1->Ione[pre_n2] ;
Ione_theta = tran1->Uone_theta ;
Ione_mag = tran1->Ione_mag  ;
Utwo_absolute = tran1->Utwo_absolute ;
Utwo_theta = tran1->Utwo_theta ;
Utwo_mag = tran1->Utwo_mag ;

Ione_total = tran1->Ione_total ;
Ione_total_mag = tran1->Ione_total_mag ;
Ione_total_theta = tran1->Ione_total_theta ;

Itwo_total = tran1->Itwo_total ;
Itwo_total_mag = tran1->Itwo_total_mag ;
Itwo_total_theta = tran1->Itwo_total_theta ;

/*			p1	     r1		p2	r2				
	h22A = ( ( beta[pre_n1] / h21)  -1 ) / rload + pin_resistance ;/*  I hate Dio-tech for Z functioning  this , Don't you ?

	h22M = -1 * ((( beta[pre_n1] * Ione_total) - Itwo_total ) / Utwo_absolute ) ; H functions by mullard don,t work here either */

	h22M1 =  Itwo_total / Utwo_absolute  ;

	h22M1_theta =  Itwo_total_theta - Utwo_theta ;

	h22M1_mag =  h22M1 / sin(h22M1_theta) ;


tran1->h22 = h22M1 ;

tran1->h22_theta = h22M1_theta ;
tran1->h22_mag = h22M1_mag ;

	return *tran1  ;

}/* END generate H21 printf("\n =%G" , ) ;*/

newtran Generate_U_2_out_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{

double Utwoout,Utwoout_mag,Utwoout_theta,Utwoout_absolute,Utwoout_real_part_1,Utwoout_imaginary_part_1,Utwoout_theta_part_1,Utwoout_square_part_1 ;
double Itwo[12],Itwo_mag,Itwo_theta,Utwoout_mag_part_1 ;
double Ic10,Ic10_theta ;
double h22,h22_mag,h22_theta ;
double Itwo_total,Itwo_total_mag,Itwo_total_theta ;
double UtwooutM1_theta,UtwooutM1_mag ;


Itwo[n] = tran1->Itwo[n] ;
Itwo_theta = tran1->Itwo_total_theta ;
Itwo_mag = tran1->Itwo_mag ;
Ic10 = tran1->Ic10[pre_n3] ;
Ic10_theta = tran1->Ic10_theta[pre_n3] ;
h22 = tran1->h22 ;
h22_mag = tran1->h22_mag ;
h22_theta = tran1->h22_theta ;

Itwo_total = tran1->Itwo_total ;
Itwo_total_mag = tran1->Itwo_total_mag ;
Itwo_total_theta = tran1->Itwo_total_theta ;

	Utwoout =  Itwo_total / h22 ;
	
	UtwooutM1_theta = Itwo_total_theta - h22_theta ;

	UtwooutM1_mag = Utwoout / sin(UtwooutM1_theta)  ;

tran1->Utwoout_absolute = Utwoout ;
tran1->Utwoout_theta = UtwooutM1_theta ;
tran1->Utwoout_mag = UtwooutM1_mag ;
tran1->Utwoout = Utwoout ;

	return *tran1  ;

}/* END generate U_2_out */

newtran Generate_h12_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{
double Uone,Uone_mag,Uone_theta,Utwo_absolute,Utwo_mag,Utwo_theta,Utwoout_absolute ;
double h12,h12_absolute,h12_theta,h12_mag ;

Uone = tran1->Uone ;
Uone_mag = tran1->Uone_mag ;
Uone_theta = tran1->Uone_theta ;
Utwo_absolute = tran1->Utwo_absolute ;
Utwo_theta = tran1->Utwo_theta ;
Utwo_mag = tran1->Utwo_mag ;

	h12 = Uone / Utwo_absolute ;
	h12_theta = Uone_theta - Utwo_theta ;
	h12_absolute = Uone_mag / Utwo_mag ;
	h12_mag =  h12_absolute / sin(h12_theta) ;
	
tran1->h12_absolute = h12_absolute ;
tran1->h12_theta = h12_theta ;
tran1->h12_mag = h12_mag ;
tran1->h12 = h12 ;

	return *tran1  ;

}/* END generate h12_ */

newtran Generate_U_1_out_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{
double Uoneout_real_part_1,Uoneout_imaginary_part_1,Uoneout_real_part_2,Uoneout_imaginary_part_2,Uoneout_square,Uoneout_absolute,Uoneout_theta ;
double h11,h11_mag,h11_theta,h12,h12_mag,h12_theta,Utwoout,Utwoout_mag,Utwoout_theta,Uoneout,Uoneout_square_part_1 ;
double Ione[10],Ione_mag,Ione_theta,Uoneout_mag,Ic10,Ic10_theta,Ic12,Ic12_theta,Ione_total,Ione_total_mag,Ione_total_theta ;
double Uoneout_mag_part_1,Uoneout_theta_part_1,Uoneout_square_part_2,Uoneout_theta_part_2,Uoneout_mag_part_2,Uoneout_real_part_3 ;
double Uoneout_imaginary_part_3,Uoneout_square_part_3,Uoneouta,Uoneout_part_1r,Uoneout_part_1i,Uoneout_part_2r,Uoneout_part_2i ;
double Uoneout_theta_part_1a,Uoneout_square_part_1a,Uoneout_absolute_part_1a,Uoneout_theta_part_2a,Uoneout_square_part_2a ;
double Uoneout_absolute_part_2a ;


h11 = tran1->h11 ;
h11_mag = tran1->h11_mag ;
h11_theta = tran1->h11_theta ;
Ione[pre_n2] = tran1->Ione[pre_n2] ;
Ione_mag = tran1->Ione_mag ;
Ione_theta = tran1->Ione_theta[pre_n2] ;
h12 = tran1->h12 ;
h12_mag = tran1->h12_mag ;
h12_theta = tran1->h12_theta ;
Utwoout = tran1->Utwoout ;
Utwoout_theta = tran1->Utwoout_theta ;
Utwoout_mag = tran1->Utwoout_mag ;
Ic10 = tran1->Ic10[pre_n3] ;
Ic10_theta = tran1->Ic10_theta[pre_n3] ;
Ic12 = tran1->Ic12[pre_n3] ;
Ic12_theta = tran1->Ic12_theta[pre_n3] ;
Ione_total = tran1->Ione_total ;
Ione_total_mag = tran1->Ione_total_mag ;
Ione_total_theta = tran1->Ione_total_theta ;

/* U1 = (h11* I one) + (h12 * U  two)   */

	Uoneouta = ( h11 * Ione_total ) + ( h12 * Utwoout) ; 

	Uoneout_part_1r =  (h11 * cos(h11_theta)) * (Ione_total * cos(Ione_total_theta)) ;
	Uoneout_part_1i =  (h11 * sin(h11_theta)) * (Ione_total * sin(Ione_total_theta)) ;
	
	Uoneout_theta_part_1a = atan(Uoneout_part_1i / Uoneout_part_1r) ;
		
	Uoneout_square_part_1a = pow(Uoneout_part_1r,2) + pow(Uoneout_part_1i,2) ;
	
	Uoneout_absolute_part_1a = sqrt(Uoneout_square_part_1a) ;	

	
	Uoneout_part_2r =  (h12 * cos(h12_theta)) * (Utwoout * cos(Utwoout_theta)) ;
	Uoneout_part_2i =  (h12 * sin(h12_theta)) * (Utwoout * sin(Utwoout_theta)) ;
		
	Uoneout_theta_part_2a = atan(Uoneout_part_2i / Uoneout_part_2r) ;

	Uoneout_square_part_2a = pow(Uoneout_part_2r,2) + pow(Uoneout_part_2i,2) ;
	
	Uoneout_absolute_part_2a = sqrt(Uoneout_square_part_2a) ;

	
	Uoneout_real_part_3 = ( Uoneout_absolute_part_1a * cos(Uoneout_theta_part_1a)) + ( Uoneout_absolute_part_2a * cos(Uoneout_theta_part_2a)) ;

   Uoneout_imaginary_part_3 = ( Uoneout_absolute_part_1a * sin(Uoneout_theta_part_1a)) + ( Uoneout_absolute_part_2a * sin(Uoneout_theta_part_2a)) ;

	Uoneout_square_part_3 = pow(Uoneout_real_part_3,2) + pow(Uoneout_imaginary_part_3,2) ;

	Uoneout_theta = atan(Uoneout_imaginary_part_3 / Uoneout_real_part_3) ;
	
	Uoneout_absolute = sqrt(Uoneout_square_part_3) ;
	
	Uoneout_mag = Uoneout_absolute / sin(Uoneout_theta) ;

tran1->Uoneout = Uoneouta ;
tran1->Uoneout_absolute = Uoneout_absolute ;
tran1->Uoneout_theta = Uoneout_theta ;
tran1->Uoneout_mag = Uoneout_mag ;

	return *tran1  ;

}/* END generate U_1_out */

 newtran Generate_U_0_out_function( int n , int pre_n1 ,int pre_n2 ,int pre_n3 , newtran *tran1 )
{
double emitterin,emitterout,Utwo_absolute,rload,Itwo[12],Itwo_mag,Itwo_theta ;
double Ic10,Ic10_theta ;
Utwo_absolute = tran1->Utwo_absolute ;
Itwo[n] = tran1->Itwo[n] ;
rload = tran1->rload ;

	emitterout = Utwo_absolute - (( Itwo[n] + (Ic10 * sin(Ic10_theta))) * rload) ;

tran1->emitterout = emitterout ;

	return *tran1  ;

}/* END generate U_0_out */







